/******************************** -*- C -*- ****************************
 *
 *	Public definitions for extensions to Smalltalk.
 *
 *	$Revision: 1.95.1$
 *	$Date: 2000/12/27 10:45:49$
 *	$Author: pb$
 *
 ***********************************************************************/


/***********************************************************************
 *
 * Copyright 1988-92, 1994-95, 1999, 2000 Free Software Foundation, Inc.
 * Written by Steve Byrne and Paolo Bonzini.
 *
 * This file is part of GNU Smalltalk.
 *
 * GNU Smalltalk is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2, or (at your option) any later 
 * version.
 * 
 * GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 *
 ***********************************************************************/


#ifndef __GSTPUB__
#define __GSTPUB__

/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#if defined(c_plusplus) && !defined(__cplusplus)
#define __cplusplus c_plusplus
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define __GST_FROM_GSTPUB_H__
#include "gst.h"
#undef __GST_FROM_GSTPUB_H__

#ifndef HAVE_STDARG_H
#ifndef __PROTO
# define __PROTO(args) ()
#endif
# define __DOTS
#else					/* must be ANSI */
#ifndef __PROTO
# define __PROTO(args) args
#endif
# define __DOTS		, ...
#endif

extern OOP	msgSend __PROTO ((OOP receiver, OOP selector __DOTS));
extern OOP      vmsgSend __PROTO ((OOP receiver, OOP selector, OOP *args));
extern OOP      nvmsgSend __PROTO ((OOP receiver, OOP selector, OOP *args, int nargs));
extern OOP	strMsgSend __PROTO ((OOP receiver __DOTS));

extern void	msgSendf __PROTO ((voidPtr resultPtr __DOTS));

/* Actually funcAddr is a function pointer, but we don't know
   the returned type so we must declare it as voidPtr */
extern void	defineCFunc __PROTO (( char *funcName, voidPtr funcAddr));
extern OOP      registerOOP __PROTO((OOP oop));
extern OOP	evalExpr __PROTO((char *str));
extern void	unregisterOOP __PROTO((OOP oop));
extern void	evalCode __PROTO((char *str));
extern void	asyncSignal __PROTO((OOP semaphoreOOP));
extern void	initSmalltalk __PROTO((void));
extern void	smalltalkArgs __PROTO((int argc, char **argv));
extern void	topLevelLoop __PROTO((void));

/* Convert C datatypes to Smalltalk types */

extern OOP	intToOOP __PROTO((long i));
extern OOP	floatToOOP __PROTO((double f));
extern OOP	boolToOOP __PROTO((int b));
extern OOP	charToOOP __PROTO((char c));
extern OOP	classNameToOOP __PROTO((char *name));
extern OOP	stringToOOP __PROTO((char *str));
extern OOP	symbolToOOP __PROTO((char *str));
extern OOP	cObjectToOOP __PROTO((voidPtr co));
extern OOP	typeNameToOOP __PROTO((char *name));

/* Convert Smalltalk datatypes to C data types */

extern long	OOPToC __PROTO((OOP oop));   /* sometimes answers a voidPtr */
extern long	OOPToInt __PROTO((OOP oop)); 
extern double	OOPToFloat __PROTO((OOP oop));
extern int 	OOPToBool __PROTO((OOP oop));
extern char	OOPToChar __PROTO((OOP oop));
extern char	*OOPToString __PROTO((OOP oop));
extern voidPtr	OOPToCObject __PROTO((OOP oop));

#define indexedWord(obj, n)   ( ((long *) ((obj) + 1))		    [(n)-1] )
#define indexedByte(obj, n)   ( ((char *) ((obj) + 1))		    [(n)-1] )
#define indexedOOP(obj, n)    ( ((OOP  *) ((obj) + 1))		    [(n)-1] )
#define arrayOOPAt(obj, n)    ( ((OOP  *) ((mst_Object) obj)->data) [(n)-1] )
#define stringOOPAt(obj, n)   ( ((char *) ((mst_Object) obj)->data) [(n)-1] )

#ifdef __cplusplus
extern "C" }
#endif

#undef __PROTO
#undef __DOTS

#endif /* __GSTPUB__ */
