"======================================================================
|
|   MulticastSocket wrapper class
|
|   $Revision: 1.95.1$
|   $Date: 2000/12/27 10:45:49$
|   $Author: pb$
|
 ======================================================================"


"======================================================================
|
| Copyright 1988-92, 1994-95, 1999, 2000 Free Software Foundation, Inc.
| Written by Paolo Bonzini.
|
| This file is part of the GNU Smalltalk class library.
|
| The GNU Smalltalk class library is free software; you can redistribute it
| and/or modify it under the terms of the GNU Lesser General Public License
| as published by the Free Software Foundation; either version 2.1, or (at
| your option) any later version.
| 
| The GNU Smalltalk class library is distributed in the hope that it will be
| useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
| General Public License for more details.
| 
| You should have received a copy of the GNU Lesser General Public License
| along with the GNU Smalltalk class library; see the file COPYING.LESSER.
| If not, write to the Free Software Foundation, 59 Temple Place - Suite
| 330, Boston, MA 02111-1307, USA.  
|
 ======================================================================"


DatagramSocket subclass: #MulticastSocket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sockets-Streams'
!

MulticastSocket defaultImplementationClass: UDPSocketImpl!

!MulticastSocket methodsFor: 'instance creation'!

interface
    ^impl ipMulticastIf
!

interface: ipAddress
    impl ipMulticastIf: ipAddress
!

join: ipAddress
    "Join the multicast socket at the given IP address"
    impl join: ipAddress
!

leave: ipAddress
    "Leave the multicast socket at the given IP address"
    impl leave: ipAddress
!

nextPut: packet timeToLive: timeToLive
    "Send the datagram with a specific TTL (time-to-live)"
    | oldTTL |
    oldTTL := impl timeToLive.
    impl timeToLive: timeToLive.
    self nextPut: packet.
    impl timeToLive: oldTTL
!

timeToLive
    "Answer the socket's datagrams' default time-to-live"
    ^impl timeToLive
!

timeToLive: newTTL
    "Set the default time-to-live for the socket's datagrams"
    impl timeToLive: newTTL
! !

!MulticastSocket methodsFor: 'private'!

create
    impl create.
    impl soReuseAddr: -1.
! !
