"======================================================================
|
|   SocketImpl
|
|   $Revision: 1.95.1$
|   $Date: 2000/12/27 10:45:49$
|   $Author: pb$
|
 ======================================================================"


"======================================================================
|
| Copyright 1988-92, 1994-95, 1999, 2000 Free Software Foundation, Inc.
| Written by Paolo Bonzini.
|
| This file is part of the GNU Smalltalk class library.
|
| The GNU Smalltalk class library is free software; you can redistribute it
| and/or modify it under the terms of the GNU Lesser General Public License
| as published by the Free Software Foundation; either version 2.1, or (at
| your option) any later version.
| 
| The GNU Smalltalk class library is distributed in the hope that it will be
| useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
| General Public License for more details.
| 
| You should have received a copy of the GNU Lesser General Public License
| along with the GNU Smalltalk class library; see the file COPYING.LESSER.
| If not, write to the Free Software Foundation, 59 Temple Place - Suite
| 330, Boston, MA 02111-1307, USA.  
|
 ======================================================================"


AbstractSocketImpl subclass: #SocketImpl
	   instanceVariableNames: 'remoteAddress remotePort '
	   classVariableNames: ''
	   poolDictionaries: ''
	   category: 'Sockets-Protocols'
!

!SocketImpl methodsFor: 'abstract'!

accept: implementationClass
    "Accept a connection on the receiver, and create a new instance
     of implementationClass that will deal with the newly created
     active server socket."
    self subclassResponsibility
!

connectTo: ipAddress port: port
    "Try to connect the socket represented by the receiver to the given remote
     machine."
    self subclassResponsibility
!

getPeerName
    "Retrieve a ByteArray containing a sockaddr_in struct for the
     remote endpoint of the socket."
    self subclassResponsibility
!

listen: backlog
    "Make the receiver a passive server socket with a pending connections
     queue of the given size."
    self subclassResponsibility
! !

!SocketImpl methodsFor: 'accessing'!

remoteAddress
    "Answer the address of the machine that the receiver is connected to."
    ^remoteAddress
!

remotePort
    "Answer the port of the socket that the receiver is connected to."
    ^remotePort
! !

!SocketImpl methodsFor: 'private'!

hasBeenConnectedTo: sockAddr
    "Store the remote address and port that the receiver is connected to."
    | port |
    port := ValueHolder new.
    remoteAddress := IPAddress fromSockAddr: sockAddr port: port.
    remotePort := port value
!

hasBeenConnected
    "Retrieve and save the remote address and port that the receiver is
     connected to."
    | peer port sizePtr |
    port := ValueHolder new.
    remoteAddress := IPAddress fromSockAddr: self getPeerName port: port.
    remotePort := port value
! !
